<template>
  <div v-if="this.$store.state.state=='RESULTS'">
    <div v-if="has_results">
      <div class="container mb-2">
        <div class="row">
          <h2 class="col no-padding">{{ result_count }} {{ $t('searchresults.results') }}</h2>
          <div id="result-action-wrapper" class="col row col-md-auto align-self-center">
            <div id="button-action-wrapper">
              <button
                id="filterCollapseButton"
                class="btn btn-primary"
                type="button"
                data-bs-toggle="collapse"
                data-bs-target="#collapseOne"
                aria-expanded="false"
                aria-controls="collapseOne">
                {{ $t('searchresults.options') }}
              </button>
              <a id="export-button" class="btn btn-primary" :href="journals_csv" download="bison_export.csv">Export</a>
              <div class="btn-group" role="group" aria-label="Switch between list and table view">
                <input type="radio" class="btn-check" name="btnradio" id="btnlist" autocomplete="off" value="list" v-model="view_type">
                <label class="btn btn-outline-primary" for="btnlist">List</label>
                <input type="radio" class="btn-check" name="btnradio" id="btntable" autocomplete="off" value="table" v-model="view_type">
                <label class="btn btn-outline-primary" for="btntable">Table</label>
              </div>
            </div>
            <div class="col no-padding">
              <select id="sort-select" v-model="sort_method" class="form-select" aria-label="Default select example">
                <option value="score" selected>{{ $t('searchresults.score') }}</option>
                <option value="title">{{ $t('searchresults.title') }}</option>
                <option value="publisher">{{ $t('searchresults.publisher') }}</option>
                <option value="apcs">{{ $t('searchresults.apcs') }}</option>
                <option value="publication_time">{{ $t('searchresults.publication_time') }}</option>
              </select>
            </div>
          </div>
        </div>
      </div>
      <search-filter-box class="collapse" id="collapseOne"/>
      <pre-filter-info />
      <search-results-list v-if="view_type == 'list' && has_filtered_results" :results="sorted_results" />
      <search-results-table v-else-if="has_filtered_results" :results="sorted_results" />
      <div v-else class="mt-3 result-msg">
        <h2>{{ $t('searchresults.no_results_filter') }}</h2>
        <p>{{ $t('searchresults.no_results_filter_explanation') }}</p>
      </div>
    </div>
    <div v-else class="result-msg">
      <h2>{{ $t('searchresults.no_results') }}</h2>
      <p>{{ $t('searchresults.no_results_explanation') }}</p>
    </div>
  </div>
  <div v-else-if="this.$store.state.state=='LOADING'" class="d-flex justify-content-center">
    <div class="spinner-border" role="status">
      <span class="visually-hidden">{{ $t('searchresults.loading') }}</span>
    </div>
  </div>
  <div v-else-if="this.$store.state.state=='ERROR'">
    <h2 class="result-msg">{{ $t('searchresults.error') }}</h2>
    <div id="image-wrapper" class="mx-auto">
      <img src="../assets/bison_sick.png" class="img-fluid" alt="sick bison">
    </div>
    <p class="result-msg">{{ this.$store.state.error }}</p>
  </div>
</template>

<script>
import SearchResultsTable from '@/components/SearchResultsTable.vue'
import SearchResultsList from '@/components/SearchResultsList.vue'
import SearchFilterBox from '@/components/SearchFilterBox.vue'
import PreFilterInfo from '@/components/PreFilterInfo.vue'
import helper from '../helper'
import { mapState } from 'vuex'

export default {
  name: 'SearchResults',
  mixins: [helper],
  components: {
    SearchResultsList,
    SearchResultsTable,
    SearchFilterBox,
    PreFilterInfo
  },
  data () {
    return {
      sort_method: 'score'
    }
  },
  computed: {
    ...mapState({
      journals: state => state.journals,
      filters: state => state.filters,
      is_extension: state => state.extension.is_set,
      mirror_handling: state => state.extension.mirror_handling
    }),
    has_results () {
      return this.journals.length > 0
    },
    result_count () {
      return this.journals.length
    },
    has_filtered_results () {
      return this.filtered_results.length > 0
    },
    sorted_results () {
      if (this.sort_method === 'publisher') {
        return this.filtered_results.slice().sort((x, y) => x.publisher_name > y.publisher_name ? 1 : -1)
      } else if (this.sort_method === 'title') {
        return this.filtered_results.slice().sort((x, y) => x.title > y.title ? 1 : -1)
      } else if (this.sort_method === 'apcs') {
        return this.filtered_results
          .slice()
          .sort((x, y) => (x.apc_max?.euro || x.apc_max?.price || 0) > (y.apc_max?.euro || y.apc_max?.price || 0) ? 1 : -1)
      } else if (this.sort_method === 'publication_time') {
        return this.filtered_results
          .slice()
          .sort((x, y) => (x.publication_time_weeks || 0) > (y.publication_time_weeks || 0) ? 1 : -1)
      } else {
        return this.filtered_results
      }
    },
    filtered_results () {
      let journals = this.journals
      if (this.is_extension && this.mirror_handling === 'HIDE') {
        journals = journals.filter(r => !r.mirror_journal)
      }
      return journals.filter(
        (e) => this.filters.copyright_author_retains === false || e.copyright_author_retains
      ).filter(
        (e) => this.filters.publication_time === false || e.publication_time_weeks <= this.filters.publication_time
      ).filter(
        // tests whether the LCC subject codes matches or the subject has length 1
        // which means it is a top level category so we only check the first letter
        // or the subject is E-F which is also a top level category :/
        (e) => this.filters.subject === '' ||
               ((this.filters.subject === 'E-F') &&
                e.subjects.reduce((pre, s) => s.code.charAt(0) === 'E' || s.code.charAt(0) === 'F', false)) ||
               ((this.filters.subject.length === 1) &&
                e.subjects.map(s => s.code.charAt(0)).flat().includes(this.filters.subject)) ||
               e.subjects.map(s => s.code).flat().includes(this.filters.subject)
      ).filter(
        (e) => this.filters.apc === false || e.has_apc === false || (e.apc_max.euro || e.apc_max.price) <= this.filters.apc
      ).filter(
        (e) => this.filters.keywords.length === 0 || this.filters.keywords.filter(v => e.keywords.includes(v)).length > 0
      ).filter(
        (e) => this.filters.language === '' || e.languages.includes(this.filters.language)
      )
    },
    journals_csv () {
      return this.journalsToCsv(this.journals)
    },
    view_type: {
      get () {
        return this.$store.state.result_view_type
      },
      set (v) {
        this.$store.commit('SET_RESULT_VIEW_TYPE', v)
      }
    }
  }
}
</script>

<style scoped>
#sort-select {
  max-width: 150pt;
  min-width: 100pt;
}
#image-wrapper {
  max-width: 400px;
}
.result-msg {
  text-align: center;
}
#export-button {
  max-width: 100px;
}
#result-action-wrapper {
  min-width: fit-content;
  row-gap: 10px;
}
#button-action-wrapper {
  display: grid;
  grid-column-gap: 10px;
  width: max-content;
}
#button-action-wrapper > * {
  grid-row: 1;
}
.no-padding {
  padding: 0 0;
}
</style>
